/**
 * @file DefaultTeamBallLocator.h
 * 
 * Implementation of class DefaultTeamBallLocator.
 *
 * @author <a href="mailto:roefer@tzi.de">Thomas Rfer</a>
 * @author Martin Ltzsch
 */

#ifndef __ATH2004TeamBallLocator_h_
#define __ATH2004TeamBallLocator_h_

#include "TeamBallLocator.h"

/**
* @class ATH2004TeamBallLocator
*
* A simple solution of the TeamBallLocator module.
*
* @author <a href="mailto:roefer@tzi.de">Thomas Rfer</a>
* @author Martin Ltzsch
*/
class ATH2004TeamBallLocator : public TeamBallLocator
{
public:
  /** 
  * Constructor.
  * @param interfaces The paramters of the TeamBallLocator module.
  */
  ATH2004TeamBallLocator(const TeamBallLocatorInterfaces& interfaces);

  /** Executes the module */
  virtual void execute();
};

#endif// __ATH2004TeamBallLocator_h_

/*
 * Change log :
 * 
 * $Log: ATH2004TeamBallLocator.h,v $
 * Revision 1.1.1.1  2004/05/22 17:22:25  cvsadm
 * created new repository GT2004_WM
 *
 * Revision 1.1  2004/04/05 17:56:47  loetzsch
 * merged the local German Open CVS of the aibo team humboldt with the tamara CVS
 *
 */
